t1.h File Reference

Implementation of the tier-1 coding (coding of code-block coefficients) (T1) More...

Go to the source code of this file.

## Data Structures

struct | opj_t1
| Tier-1 coding (coding of code-block coefficients) More...

## Macros

#define | T1_NMSEDEC_BITS 7
#define | T1_NUMCTXS_ZC 9
#define | T1_NUMCTXS_SC 5
#define | T1_NUMCTXS_MAG 3
#define | T1_NUMCTXS_AGG 1
#define | T1_NUMCTXS_UNI 1
#define | T1_CTXNO_ZC 0
#define | T1_CTXNO_SC (T1_CTXNO_ZC+T1_NUMCTXS_ZC)
#define | T1_CTXNO_MAG (T1_CTXNO_SC+T1_NUMCTXS_SC)
#define | T1_CTXNO_AGG (T1_CTXNO_MAG+T1_NUMCTXS_MAG)
#define | T1_CTXNO_UNI (T1_CTXNO_AGG+T1_NUMCTXS_AGG)
#define | T1_NUMCTXS (T1_CTXNO_UNI+T1_NUMCTXS_UNI)
#define | T1_NMSEDEC_FRACBITS (T1_NMSEDEC_BITS-1)
#define | T1_TYPE_MQ 0
| Normal coding using entropy coder.
#define | T1_TYPE_RAW 1
| No encoding the information is store under raw format in codestream (mode switch RAW)
#define | T1_SIGMA_0 (1U << 0)
| We hold the state of individual data points for the T1 encoder using a single 32-bit flags word to hold the state of 4 data points.
#define | T1_SIGMA_1 (1U << 1)
#define | T1_SIGMA_2 (1U << 2)
#define | T1_SIGMA_3 (1U << 3)
#define | T1_SIGMA_4 (1U << 4)
#define | T1_SIGMA_5 (1U << 5)
#define | T1_SIGMA_6 (1U << 6)
#define | T1_SIGMA_7 (1U << 7)
#define | T1_SIGMA_8 (1U << 8)
#define | T1_SIGMA_9 (1U << 9)
#define | T1_SIGMA_10 (1U << 10)
#define | T1_SIGMA_11 (1U << 11)
#define | T1_SIGMA_12 (1U << 12)
#define | T1_SIGMA_13 (1U << 13)
#define | T1_SIGMA_14 (1U << 14)
#define | T1_SIGMA_15 (1U << 15)
#define | T1_SIGMA_16 (1U << 16)
#define | T1_SIGMA_17 (1U << 17)
#define | T1_CHI_0 (1U << 18)
#define | T1_CHI_0_I 18
#define | T1_CHI_1 (1U << 19)
#define | T1_CHI_1_I 19
#define | T1_MU_0 (1U << 20)
#define | T1_PI_0 (1U << 21)
#define | T1_CHI_2 (1U << 22)
#define | T1_CHI_2_I 22
#define | T1_MU_1 (1U << 23)
#define | T1_PI_1 (1U << 24)
#define | T1_CHI_3 (1U << 25)
#define | T1_MU_2 (1U << 26)
#define | T1_PI_2 (1U << 27)
#define | T1_CHI_4 (1U << 28)
#define | T1_MU_3 (1U << 29)
#define | T1_PI_3 (1U << 30)
#define | T1_CHI_5 (1U << 31)
#define | T1_CHI_5_I 31
#define | T1_SIGMA_NW T1_SIGMA_0
| As an example, the bits T1_SIGMA_3, T1_SIGMA_4 and T1_SIGMA_5 indicate the significance state of the west neighbour of data point zero of our four, the point itself, and its east neighbour respectively.
#define | T1_SIGMA_N T1_SIGMA_1
#define | T1_SIGMA_NE T1_SIGMA_2
#define | T1_SIGMA_W T1_SIGMA_3
#define | T1_SIGMA_THIS T1_SIGMA_4
#define | T1_SIGMA_E T1_SIGMA_5
#define | T1_SIGMA_SW T1_SIGMA_6
#define | T1_SIGMA_S T1_SIGMA_7
#define | T1_SIGMA_SE T1_SIGMA_8
#define | T1_SIGMA_NEIGHBOURS (T1_SIGMA_NW | T1_SIGMA_N | T1_SIGMA_NE | T1_SIGMA_W | T1_SIGMA_E | T1_SIGMA_SW | T1_SIGMA_S | T1_SIGMA_SE)
#define | T1_CHI_THIS T1_CHI_1
#define | T1_CHI_THIS_I T1_CHI_1_I
#define | T1_MU_THIS T1_MU_0
#define | T1_PI_THIS T1_PI_0
#define | T1_CHI_S T1_CHI_2
#define | T1_LUT_SGN_W (1U << 0)
#define | T1_LUT_SIG_N (1U << 1)
#define | T1_LUT_SGN_E (1U << 2)
#define | T1_LUT_SIG_W (1U << 3)
#define | T1_LUT_SGN_N (1U << 4)
#define | T1_LUT_SIG_E (1U << 5)
#define | T1_LUT_SGN_S (1U << 6)
#define | T1_LUT_SIG_S (1U << 7)

## Typedefs

typedef OPJ_UINT32 | opj_flag_t
| Flags for 4 consecutive rows of a column.
typedef struct opj_t1 | opj_t1_t
| Tier-1 coding (coding of code-block coefficients)

## Functions

Exported functions
OPJ_BOOL | opj_t1_encode_cblks (opj_tcd_t *tcd, opj_tcd_tile_t *tile, opj_tcp_t *tcp, const OPJ_FLOAT64 *mct_norms, OPJ_UINT32 mct_numcomps)
| Encode the code-blocks of a tile.
void | opj_t1_decode_cblks (opj_tcd_t *tcd, volatile OPJ_BOOL *pret, opj_tcd_tilecomp_t *tilec, opj_tccp_t *tccp, opj_event_mgr_t *p_manager, opj_mutex_t *p_manager_mutex, OPJ_BOOL check_pterm)
| Decode the code-blocks of a tile.
opj_t1_t * | opj_t1_create (OPJ_BOOL isEncoder)
| Creates a new Tier 1 handle and initializes the look-up tables of the Tier-1 coder/decoder.
void | opj_t1_destroy (opj_t1_t *p_t1)
| Destroys a previously created T1 handle.

## Detailed Description

Implementation of the tier-1 coding (coding of code-block coefficients) (T1)

The functions in T1.C have for goal to realize the tier-1 coding operation. The functions in T1.C are used by some function in TCD.C.

## Macro Definition Documentation

## T1_CHI_0

#define T1_CHI_0 (1U << 18)

## T1_CHI_0_I

#define T1_CHI_0_I 18

## T1_CHI_1

#define T1_CHI_1 (1U << 19)

## T1_CHI_1_I

#define T1_CHI_1_I 19

## T1_CHI_2

#define T1_CHI_2 (1U << 22)

## T1_CHI_2_I

#define T1_CHI_2_I 22

## T1_CHI_3

#define T1_CHI_3 (1U << 25)

## T1_CHI_4

#define T1_CHI_4 (1U << 28)

## T1_CHI_5

#define T1_CHI_5 (1U << 31)

## T1_CHI_5_I

#define T1_CHI_5_I 31

## T1_CHI_S

#define T1_CHI_S T1_CHI_2

## T1_CHI_THIS

#define T1_CHI_THIS T1_CHI_1

## T1_CHI_THIS_I

#define T1_CHI_THIS_I T1_CHI_1_I

## T1_CTXNO_AGG

#define T1_CTXNO_AGG (T1_CTXNO_MAG+T1_NUMCTXS_MAG)

## T1_CTXNO_MAG

#define T1_CTXNO_MAG (T1_CTXNO_SC+T1_NUMCTXS_SC)

## T1_CTXNO_SC

#define T1_CTXNO_SC (T1_CTXNO_ZC+T1_NUMCTXS_ZC)

## T1_CTXNO_UNI

#define T1_CTXNO_UNI (T1_CTXNO_AGG+T1_NUMCTXS_AGG)

## T1_CTXNO_ZC

#define T1_CTXNO_ZC 0

## T1_LUT_SGN_E

#define T1_LUT_SGN_E (1U << 2)

## T1_LUT_SGN_N

#define T1_LUT_SGN_N (1U << 4)

## T1_LUT_SGN_S

#define T1_LUT_SGN_S (1U << 6)

## T1_LUT_SGN_W

#define T1_LUT_SGN_W (1U << 0)

## T1_LUT_SIG_E

#define T1_LUT_SIG_E (1U << 5)

## T1_LUT_SIG_N

#define T1_LUT_SIG_N (1U << 1)

## T1_LUT_SIG_S

#define T1_LUT_SIG_S (1U << 7)

## T1_LUT_SIG_W

#define T1_LUT_SIG_W (1U << 3)

## T1_MU_0

#define T1_MU_0 (1U << 20)

## T1_MU_1

#define T1_MU_1 (1U << 23)

## T1_MU_2

#define T1_MU_2 (1U << 26)

## T1_MU_3

#define T1_MU_3 (1U << 29)

## T1_MU_THIS

#define T1_MU_THIS T1_MU_0

## T1_NMSEDEC_BITS

#define T1_NMSEDEC_BITS 7

## T1_NMSEDEC_FRACBITS

#define T1_NMSEDEC_FRACBITS (T1_NMSEDEC_BITS-1)

## T1_NUMCTXS

#define T1_NUMCTXS (T1_CTXNO_UNI+T1_NUMCTXS_UNI)

## T1_NUMCTXS_AGG

#define T1_NUMCTXS_AGG 1

## T1_NUMCTXS_MAG

#define T1_NUMCTXS_MAG 3

## T1_NUMCTXS_SC

#define T1_NUMCTXS_SC 5

## T1_NUMCTXS_UNI

#define T1_NUMCTXS_UNI 1

## T1_NUMCTXS_ZC

#define T1_NUMCTXS_ZC 9

## T1_PI_0

#define T1_PI_0 (1U << 21)

## T1_PI_1

#define T1_PI_1 (1U << 24)

## T1_PI_2

#define T1_PI_2 (1U << 27)

## T1_PI_3

#define T1_PI_3 (1U << 30)

## T1_PI_THIS

#define T1_PI_THIS T1_PI_0

## T1_SIGMA_0

#define T1_SIGMA_0 (1U << 0)

We hold the state of individual data points for the T1 encoder using a single 32-bit flags word to hold the state of 4 data points.

This corresponds to the 4-point-high columns that the data is processed in.

These #defines declare the layout of a 32-bit flags word.

This is currently done for encoding only. The values must NOT be changed, otherwise this is going to break a lot of assumptions.

## T1_SIGMA_1

#define T1_SIGMA_1 (1U << 1)

## T1_SIGMA_10

#define T1_SIGMA_10 (1U << 10)

## T1_SIGMA_11

#define T1_SIGMA_11 (1U << 11)

## T1_SIGMA_12

#define T1_SIGMA_12 (1U << 12)

## T1_SIGMA_13

#define T1_SIGMA_13 (1U << 13)

## T1_SIGMA_14

#define T1_SIGMA_14 (1U << 14)

## T1_SIGMA_15

#define T1_SIGMA_15 (1U << 15)

## T1_SIGMA_16

#define T1_SIGMA_16 (1U << 16)

## T1_SIGMA_17

#define T1_SIGMA_17 (1U << 17)

## T1_SIGMA_2

#define T1_SIGMA_2 (1U << 2)

## T1_SIGMA_3

#define T1_SIGMA_3 (1U << 3)

## T1_SIGMA_4

#define T1_SIGMA_4 (1U << 4)

## T1_SIGMA_5

#define T1_SIGMA_5 (1U << 5)

## T1_SIGMA_6

#define T1_SIGMA_6 (1U << 6)

## T1_SIGMA_7

#define T1_SIGMA_7 (1U << 7)

## T1_SIGMA_8

#define T1_SIGMA_8 (1U << 8)

## T1_SIGMA_9

#define T1_SIGMA_9 (1U << 9)

## T1_SIGMA_E

#define T1_SIGMA_E T1_SIGMA_5

## T1_SIGMA_N

#define T1_SIGMA_N T1_SIGMA_1

## T1_SIGMA_NE

#define T1_SIGMA_NE T1_SIGMA_2

## T1_SIGMA_NEIGHBOURS

#define T1_SIGMA_NEIGHBOURS (T1_SIGMA_NW | T1_SIGMA_N | T1_SIGMA_NE | T1_SIGMA_W | T1_SIGMA_E | T1_SIGMA_SW | T1_SIGMA_S | T1_SIGMA_SE)

## T1_SIGMA_NW

#define T1_SIGMA_NW T1_SIGMA_0

As an example, the bits T1_SIGMA_3, T1_SIGMA_4 and T1_SIGMA_5 indicate the significance state of the west neighbour of data point zero of our four, the point itself, and its east neighbour respectively.

Many of the bits are arranged so that given a flags word, you can look at the values for the data point 0, then shift the flags word right by 3 bits and look at the same bit positions to see the values for data point 1.

The #defines below help a bit with this; say you have a flags word f, you can do things like

(f & T1_SIGMA_THIS)

to see the significance bit of data point 0, then do

((f >> 3) & T1_SIGMA_THIS)

to see the significance bit of data point 1.

## T1_SIGMA_S

#define T1_SIGMA_S T1_SIGMA_7

## T1_SIGMA_SE

#define T1_SIGMA_SE T1_SIGMA_8

## T1_SIGMA_SW

#define T1_SIGMA_SW T1_SIGMA_6

## T1_SIGMA_THIS

#define T1_SIGMA_THIS T1_SIGMA_4

## T1_SIGMA_W

#define T1_SIGMA_W T1_SIGMA_3

## T1_TYPE_MQ

#define T1_TYPE_MQ 0

Normal coding using entropy coder.

## T1_TYPE_RAW

#define T1_TYPE_RAW 1

No encoding the information is store under raw format in codestream (mode switch RAW)

## Typedef Documentation

## opj_flag_t

typedef OPJ_UINT32 opj_flag_t

Flags for 4 consecutive rows of a column.

## opj_t1_t

typedef struct opj_t1 opj_t1_t

Tier-1 coding (coding of code-block coefficients)

## Function Documentation

## opj_t1_create()

opj_t1_t * opj_t1_create | ( | OPJ_BOOL | isEncoder | ) |

Creates a new Tier 1 handle and initializes the look-up tables of the Tier-1 coder/decoder.

Returns
  a new T1 handle if successful, returns NULL otherwise

References opj_t1::encoder, and opj_calloc().

Referenced by opj_t1_cblk_encode_processor(), and opj_t1_clbl_decode_processor().

## opj_t1_decode_cblks()

void opj_t1_decode_cblks | ( | opj_tcd_t * | tcd,
|  | volatile OPJ_BOOL * | pret,
|  | opj_tcd_tilecomp_t * | tilec,
|  | opj_tccp_t * | tccp,
|  | opj_event_mgr_t * | p_manager,
|  | opj_mutex_t * | p_manager_mutex,
|  | OPJ_BOOL | check_pterm
| ) |  |

Decode the code-blocks of a tile.

Parameters

  tcd | TCD handle
  pret | Pointer to return value
  tilec | The tile to decode
  tccp | Tile coding parameters
  p_manager | the event manager
  p_manager_mutex | mutex for the event manager
  check_pterm | whether PTERM correct termination should be checked

References opj_t1_cblk_decode_processing_job_t::band, opj_tcd_resolution::bands, opj_t1_cblk_decode_processing_job_t::cblk, opj_tcd_precinct::cblks, opj_tcd_precinct::ch, opj_t1_cblk_decode_processing_job_t::check_pterm, opj_tcd_tilecomp::compno, opj_tcd_precinct::cw, opj_tcd_precinct::dec, opj_tcd_cblk_dec::decoded_data, opj_tcd_tilecomp::minimum_num_resolutions, opj_t1_cblk_decode_processing_job_t::mustuse_cblkdatabuffer, opj_tcd_resolution::numbands, opj_aligned_free(), opj_calloc(), OPJ_FALSE, OPJ_RESTRICT, opj_t1_clbl_decode_processor(), opj_tcd_is_subband_area_of_interest(), opj_thread_pool_get_thread_count(), opj_thread_pool_submit_job(), opj_t1_cblk_decode_processing_job_t::p_manager, opj_t1_cblk_decode_processing_job_t::p_manager_mutex, opj_tcd_resolution::ph, opj_t1_cblk_decode_processing_job_t::pret, opj_tcd_resolution::pw, opj_t1_cblk_decode_processing_job_t::resno, opj_tcd_tilecomp::resolutions, opj_t1_cblk_decode_processing_job_t::tccp, opj_tcd::thread_pool, opj_t1_cblk_decode_processing_job_t::tilec, opj_t1_cblk_decode_processing_job_t::whole_tile_decoding, opj_tcd::whole_tile_decoding, opj_tcd_cblk_dec::x0, opj_tcd_precinct::x0, opj_tcd_cblk_dec::x1, opj_tcd_precinct::x1, opj_tcd_cblk_dec::y0, opj_tcd_precinct::y0, opj_tcd_cblk_dec::y1, and opj_tcd_precinct::y1.

Referenced by opj_tcd_t1_decode().

## opj_t1_destroy()

void opj_t1_destroy | ( | opj_t1_t * | p_t1 | ) |

Destroys a previously created T1 handle.

Parameters

  p_t1 | Tier 1 handle to destroy

References opj_t1::cblkdatabuffer, opj_t1::data, opj_t1::flags, opj_aligned_free(), and opj_free().

Referenced by opj_t1_clbl_decode_processor(), and opj_t1_destroy_wrapper().

## opj_t1_encode_cblks()

OPJ_BOOL opj_t1_encode_cblks | ( | opj_tcd_t * | tcd,
|  | opj_tcd_tile_t * | tile,
|  | opj_tcp_t * | tcp,
|  | const OPJ_FLOAT64 * | mct_norms,
|  | OPJ_UINT32 | mct_numcomps
| ) |  |

Encode the code-blocks of a tile.

Parameters

  tcd | TCD handle
  tile | The tile to encode
  tcp | Tile coding parameters
  mct_norms | FIXME DOC
  mct_numcomps | Number of components used for MCT

References opj_t1_cblk_encode_processing_job_t::band, opj_tcd_resolution::bands, opj_t1_cblk_encode_processing_job_t::cblk, opj_tcd_precinct::cblks, opj_tcd_precinct::ch, opj_t1_cblk_encode_processing_job_t::compno, opj_tcd_tile::comps, opj_tcd_precinct::cw, opj_tcd_tile::distotile, opj_tcd_precinct::enc, opj_t1_cblk_encode_processing_job_t::mct_norms, opj_t1_cblk_encode_processing_job_t::mct_numcomps, opj_t1_cblk_encode_processing_job_t::mutex, opj_tcd_resolution::numbands, opj_tcd_tile::numcomps, opj_tcd_tilecomp::numresolutions, opj_calloc(), OPJ_FALSE, opj_mutex_create(), opj_mutex_destroy(), OPJ_RESTRICT, opj_t1_cblk_encode_processor(), opj_tcd_is_band_empty(), opj_thread_pool_submit_job(), opj_thread_pool_wait_completion(), OPJ_TRUE, opj_tcd_resolution::ph, opj_t1_cblk_encode_processing_job_t::pret, opj_tcd_resolution::pw, opj_t1_cblk_encode_processing_job_t::resno, opj_tcd_tilecomp::resolutions, opj_t1_cblk_encode_processing_job_t::tccp, tcp, opj_tcd::thread_pool, opj_t1_cblk_encode_processing_job_t::tile, and opj_t1_cblk_encode_processing_job_t::tilec.

Referenced by opj_tcd_t1_encode().